View Issue Details

IDProjectCategoryLast Update
0021516AI War 2[All Projects] SuggestionOct 7, 2019 2:25 pm
ReporterBadgerBadgerAssigned ToBadgerBadger 
Severityminor 
Status resolvedResolutionfixed 
Product Version0.882-0.883 Research and Reconquest 
Fixed in Version0.898 Galactic Linkages 
Summary0021516: Allow Nanocaust ships to stack
DescriptionI think I figured out a mechanism for this, and it should be a nice performance boost.
TagsNo tags attached.

Relationships

related to 0021513 resolvedx4000Bughunter Slow Performance and other oddities 

Activities

x4000Bughunter

Aug 26, 2019 11:50 am

administrator   ~0052629

Got it as part of this:

* AI guardians and dire guardians are now allowed to stack, which also means that other things like nanocaust ships (which are flagged as such) are now also able to stack. This gives a pretty major performance boost in some games that were previously bogged down because of a ton of those sorts of ships that were not stacking.

Thanks!

x4000Bughunter

Aug 26, 2019 12:01 pm

administrator   ~0052631

Whoops!

* Added SmallShipNotStackable and LargeShipNotStackable, which don't have the other AIGuardian logic or flags, but which prevent stacking of them.
** Currently applied LargeShipNotStackable to: dark spire ships (is this needed?), dyson ships (is this needed?), macrophage harvesters (is this needed?), nanocaust ships (this is needed, for now at least, to not let them stack across different spawners).
** Thanks to Badger for reporting the problems that the change to AI Guardians stacking logic could cause with some of the other factions. This makes the performance worse (for now) with the nanocaust again, but it does make it so that guardians are stackable.

BadgerBadger

Aug 26, 2019 12:38 pm

manager   ~0052633

If anyone is curious, each Nanobot center is only allowed to have a certain number of ships in the galaxy for balance reasons (otherwise the nanocaust would be basically unstoppable). During a SimStep where the nanocaust is allowed to produce ships, the game will count the ships from each nanobot center to know if a given center is allowed to make more ships. If ships from different centers stack together then it makes it impossible to still track which centers are allowed to produce new ships.

The fix is going to be implementing code for "this unit is allowed to stack only with other units from the same nanobot center"

x4000Bughunter

Aug 26, 2019 1:32 pm

administrator   ~0052635

This will help some when the time comes:

* Added SmallShipYesStacks and LargeShipYesStacks, which are like their non-stacking variants but do stack.
** Now applied LargeShipYesStacks to: dark spire ships and dyson ships.
** Macrophage ships are not supposed to stack, and are rare enough that they don't even need to. Nanocaust stuff will be dealt with later on, made to stack but only with extra conditionality.

BadgerBadger

Oct 7, 2019 2:25 pm

manager   ~0053531

Nanocaust and Marauders can now stack. More testing is needed of course.

Issue History

Date Modified Username Field Change
Aug 21, 2019 12:41 am BadgerBadger New Issue
Aug 21, 2019 12:41 am BadgerBadger Status new => assigned
Aug 21, 2019 12:41 am BadgerBadger Assigned To => BadgerBadger
Aug 26, 2019 11:50 am x4000Bughunter Assigned To BadgerBadger => x4000Bughunter
Aug 26, 2019 11:50 am x4000Bughunter Status assigned => resolved
Aug 26, 2019 11:50 am x4000Bughunter Resolution open => fixed
Aug 26, 2019 11:50 am x4000Bughunter Fixed in Version => 0.884 The Helping Hat
Aug 26, 2019 11:50 am x4000Bughunter Note Added: 0052629
Aug 26, 2019 12:01 pm x4000Bughunter Assigned To x4000Bughunter => BadgerBadger
Aug 26, 2019 12:01 pm x4000Bughunter Status resolved => assigned
Aug 26, 2019 12:01 pm x4000Bughunter Note Added: 0052631
Aug 26, 2019 12:01 pm x4000Bughunter Relationship added related to 0021513
Aug 26, 2019 12:38 pm BadgerBadger Note Added: 0052633
Aug 26, 2019 1:32 pm x4000Bughunter Note Added: 0052635
Oct 7, 2019 2:25 pm BadgerBadger Status assigned => resolved
Oct 7, 2019 2:25 pm BadgerBadger Fixed in Version 0.884 The Helping Hat => 0.898 Galactic Linkages
Oct 7, 2019 2:25 pm BadgerBadger Note Added: 0053531